clear 
close all

% Get data from CSV, exported from GH
data = csvread("EccOut.csv");

% First row contains N number of points
numPoints = (data(1,1));

% Next N rows contain colour data for graphing
colour = data(2:numPoints+1,:);
%colour = circshift(colour, [2,0]);
% Remove these first rows and the numeric indices
points = data(numPoints+2:size(data, 1), 2:3);

% Get number of data points per location
numPerPoint = length(points)/numPoints;

% Reshape into something more useful
%points = reshape(points', numPerPoint,2, numPoints);
%pointsReshaped(:,:,i) = points()
for i=1:numPoints
    pointsReshaped(:,:,i) = points(1+(i-1)*numPerPoint : i*numPerPoint, : );
end
pointsReshaped = circshift(pointsReshaped, [0,0,2]);

Ntlist = [0, 474];
for s = [1,2]
    subplot(1,2,s)
    hold on;
    legstr = [];
    
    Nt = Ntlist(s);%0.04e6*(3.6/100);
    
    for i = 1:numPoints
        colourPlot = colour(i,:)/255.0;
        plot(pointsReshaped(:,1,i)-Nt, pointsReshaped(:,2,i), "Color", colourPlot, "LineWidth", 2)
        legstr(i) = i;
    end
    
    xL = get(gca,'xlim');
    disp(xL)
    xL(2)=100;
    eccLim = 1/6;
    eccMax = xL*eccLim;
    
%     xL(2) = 0;
    set(gca, 'xlim', xL);
    eccMax = xL*eccLim;
    
    plot([xL(1), xL(2)], [eccMax(1), eccMax(2)], "red", "LineWidth", 3);
    plot([xL(1), xL(2)], [-eccMax(1), -eccMax(2)], "red", "LineWidth", 3);
    
    lrgY = max(abs(eccMax));
    ylim(gca, [-lrgY, lrgY])
    ylim(gca, [-150, 150])
    
    legend([legstr "lim_{INF}" "lim_{SUP}"],'Location','bestoutside')
    
    hold off;
    
    ax = gca;
    ax.XAxisLocation = 'origin';
    ax.YAxisLocation = 'origin';
    ax.XLabel.Units = "normalized"; 
    
    xlabel('$N \ \ (N/m)$','interpreter','latex','fontsize',20)
    ylabel('$M/h \ \ (N \cdot m/m)$','interpreter','latex','fontsize',20)
end
hold on
plot([-Nt,-Nt], [-150, 150], ":", "color", "#B2BEB5", "Linewidth", 3)

subplot(1,2,2)
axis square

xLNew = xlim
subplot(1,2,1)
xlim(xLNew)
axis square
