clear;
Out = 1;
%Result = {};
% input
sth=0.036; % shell thickness
limth=1/6; %R-Funicularity limit


% Inizializzazione modello SAP2000
% INITIALIZATION
% Set the program executable path
ProgramPath = 'C:\Program Files\Computers and Structures\SAP2000 24\SAP2000.exe';
feature('COM_SafeArraySingleDim', 1);
feature('COM_PassSafeArrayByRef', 1);
% Set the API dll path
APIDLLPath = 'C:\Program Files\Computers and Structures\SAP2000 24\SAP2000v1.dll';
% Create OAPI helper object
a = NET.addAssembly(APIDLLPath);
helper = SAP2000v1.Helper;
helper = NET.explicitCast(helper,'SAP2000v1.cHelper');
% Create Sap2000 object
%SapObject = helper.CreateObject(ProgramPath);
% Link to an existing Sap2000 Object
SapObject = helper.GetObject('CSI.SAP2000.API.SapObject');
SapObject = NET.explicitCast(SapObject,'SAP2000v1.cOAPI');
% Start Sap2000 application
%SapObject.ApplicationStart;
% Hide Sap2000 application
%SapObject.Hide;
% Create SapModel object
SapModel = NET.explicitCast(SapObject.SapModel,'SAP2000v1.cSapModel');
% Initialize model
%SapModel.InitializeNewModel;
% Open user defined .sdb model: set FileName as the name of the model
% to be analyzed
%File = NET.explicitCast(SapModel.File,'SAP2000v1.cFile');
%File.OpenFile([pwd, '\', FileName, '.sdb']);
% Set units
%SapModel.SetPresentUnits(SAP2000v1.eUnits.kN_m_C);
% Unlock the model
%SapModel.SetModelIsLocked(false);

AnalysisResults = NET.explicitCast(SapModel.Results,'SAP2000v1.cAnalysisResults');
AnalysisResultsSetup = NET.explicitCast(AnalysisResults.Setup,'SAP2000v1.cAnalysisResultsSetup');
ret = AnalysisResultsSetup.SetCaseSelectedForOutput('DEAD');
SelObj = NET.explicitCast(SapModel.SelectObj,'SAP2000v1.cSelect');
PObj = NET.explicitCast(SapModel.PointObj,'SAP2000v1.cPointObj');
AObj = NET.explicitCast(SapModel.AreaObj, "SAP2000v1.cAreaObj");

% memo: methods(SelObj)
% 
% read the selected elements

ElemSel=0;
ObjectType=0;
ObjName=cellstr('');
SelObj.All();
[ret,~,ObjectType,ObjName] = SelObj.GetSelected(ElemSel,ObjectType,ObjName);
ObjName=cell(ObjName);
ObjectType=double(ObjectType);
ShellObj=ObjName(find(ObjectType==5));
PointObj=ObjName(find(ObjectType==1));


for ii = 1:length(ShellObj)
    ItemType = SAP2000v1.eItemTypeElm;
    NumberResults = 0;
    Obj = cellstr('');
    Elm = cellstr('');
    PointElm = cellstr('');
    LoadCase = cellstr('');
    StepType = cellstr('');
    StepNum = 0;
    F11 = 0;
    F22 = 0;
    F12 = 0;
    FMax = 0;
    FMin = 0;
    FAngle = 0;
    FVM = 0;
    M11 = 0;
    M22 = 0;
    M12 = 0;
    MMax = 0;
    MMin = 0;
    MAngle = 0;
    V13 = 0;
    V23 = 0;
    VMax = 0;
    VAngle = 0;
        
    [~, ~, ~, Elm, PointElm, ~,StepType, StepNum,F11,F22,F12,FMax,FMin,FAngle,~,M11,M22,M12,MMax,MMin,MAngle,~,~,~,~] =...
        AnalysisResults.AreaForceShell(ShellObj{ii}, ItemType, NumberResults, Obj, Elm, PointElm, LoadCase, StepType,...
        StepNum,F11,F22,F12,FMax,FMin,FAngle,FVM,M11,M22,M12,MMax,MMin,MAngle,V13,V23,VMax,VAngle);
    
    F11 = double(F11);
    F22 = double(F22);
    F12 = double(F12);
    FMax = double(FMax);
    FMin = double(FMin);
    FAngle = double(FAngle);
    FVM = double(FVM);
    M11 = double(M11);
    M22 = double(M22);
    M12 = double(M12);
    MMax = double(MMax);
    MMin = double(MMin);
    MAngle = double(MAngle);
    V13 = double(V13);
    V23 = double(V23);
    VMax = double(VMax);
    VAngle = double(VAngle);
    Elm=cell(Elm);
    
    PuntiShell{ii,1} = cell(PointElm);
    
    appoRes= mean([F11',F22',F12',FMax',FMin',FAngle',M11',M22',M12',MMax',MMin',MAngle']); % [Result;FM_Read]; %#ok<AGROW>
    %, str2num(Elm{1}(1:end))];

    ItemType = SAP2000v1.eItemTypeElm;
    NumberResults = 0;
    Obj = cellstr('');
    Elm = cellstr('');
    Point = cellstr('');
    LoadCase = cellstr('');
    StepType = cellstr('');
    StepNum = 0;
    
    [ret,x1,y1,z1]=PObj.GetCoordCartesian(PuntiShell{ii,1}{1},0,0,0);
    [ret,x2,y2,z2]=PObj.GetCoordCartesian(PuntiShell{ii,1}{2},0,0,0);
    [ret,x3,y3,z3]=PObj.GetCoordCartesian(PuntiShell{ii,1}{3},0,0,0);
    
    x=mean([double(x1), double(x2), double(x3)]);
    y=mean([double(y1), double(y2), double(y3)]);
    z=mean([double(z1), double(z2), double(z3)]);    

    Result(ii,:)=[appoRes, x, y, z];
   
    % F11,F22,F12,FMax,FMin,FAngle,M11,M22,M12,MMax,MMin,MAngle, x, y, z
    % (ave.)
     
end

%NOW TO ANALYSE
syms alpha real

num_funicular = 0;
num_non_normal = 0;
u=[cos(alpha); sin(alpha)];

for ii=1:length(Result(:,1))
    %disp(100*ii/length(Result(:,1)));
    nn=Result(ii,1:3);
    mm=Result(ii,7:9)/sth;
    
    % Membrane forces
    N11=nn(1);
    N22=nn(2);
    N12=nn(3);
    
    % Moments
    M11=mm(1);
    M22=mm(2);
    M12=mm(3);
    
    % Membrane force tensor
    N=[N11 N12
        N12 N22];

    %N = N - 4.7448e+03*eye(2);
    
    % Moment tensor
    M=[M11 M12
        M12 M22];
    
    % builds the quadratic forms and calculates the generalized
    % eccentricity
    Na=u'*N*u;
    Ma=u'*M*u;
    ea=Ma/Na;
    
    % numerical array for alpha
    aint=[0:pi/72:pi];
       
    % applies the algorithm given in 
    % Gabriele et al. "R-Funicularity of form found shell structures"
    % Engineering Structures, 157, pp.157-169, (2018).
    Nsph=trace(N)/2*eye(2);
    Msph=trace(M)/2*eye(2);
    Ndev=N-Nsph;
    Mdev=M-Msph;
    Nc=(N(1,1)-N(2,2))/2;
    Mc=(M(1,1)-M(2,2))/2;
    D=[Nc N(1,2); Mc M(1,2)];
    
    %algorithm
    dN=det(N);
    dM=det(M);
    dD=det(D);
    
    % Equation (17) in the paper
    if rank(N)>1 %not(dN==0)
        A=inv(N)*M;
        %disp('case 1')
        casenum(ii) = 1;
        e1=0.5*(trace(A)-sqrt(trace(A)^2-4*det(A)));
        e2=0.5*(trace(A)+sqrt(trace(A)^2-4*det(A)));
    elseif and(rank(N)<2,rank(M)>1)%and(dN==0,not(dM==0))
        %disp('case 2')
        casenum(ii) = 2;
        A=inv(M)*N;
        e1=0.5/(trace(A)-sqrt(trace(A)^2-4*det(A)));
        e2=0.5/(trace(A)+sqrt(trace(A)^2-4*det(A)));
    elseif and(and(rank(N)<2,rank(M)<2),rank(D)>1)%and(and(dN==0,dM==0),not(dD==0))
        %disp('case 3')
        casenum(ii) = 3;
        e1=0;
        e2=inf;
    elseif and(and(rank(N)<2,rank(M)<2),rank(D)<2)%and(and(dN==0,dM==0),dD==0)
        %disp('case 4')
        casenum(ii) = 4;
        e1=trace(M)/trace(N);
        e2=trace(M)/trace(N);
    else
        %disp('no case')
        casenum(ii) = -1;
    end

    if (max(abs(e1), abs(e2)) < limth)
        num_funicular = num_funicular +1;
    end

    if det(N)<0
        disp("Node " +string(ii))
        if det(M)<0
            disp('No Local Extrema - |e{min,max}|=inf (complex - centred at 0,0)')
            disp([e1,e2])

            caseid(ii)=2;
        else
            disp('Local Extrema n.e. Global Extrema -> |e{min,max}|=inf (On line of N=0)')
            disp([e1,e2])

            caseid(ii)=3;
        end
%         disp([rank(N),rank(M)]);
%         disp(N);
%         disp(M);
        num_non_normal = num_non_normal+1;
    else
        caseid(ii) = 1;
    end
    
    Result2(ii,:) = [(Result(ii, :)), abs(e1), abs(e2), caseid(ii)];
end

disp([string(num_funicular) + " regions funicular => " + string(100*num_funicular/ii) + "%"])
csvwrite("Results.csv", Result2);    